5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 . "${source_path}/build/make/configure.sh"
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 ${toggle_fast_unaligned} don't use unaligned accesses, even when
27 supported by hardware [auto]
28 ${toggle_codec_srcs} in/exclude codec library source code
29 ${toggle_debug_libs} in/exclude debug version of libraries
30 ${toggle_md5} support for output of checksum data
31 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
32 ${toggle_vp8} VP8 codec support
33 ${toggle_psnr} output of PSNR data, if supported (encoders)
34 ${toggle_mem_tracker} track memory usage
35 ${toggle_postproc} postprocessing
36 ${toggle_multithread} multithreaded encoding and decoding.
37 ${toggle_spatial_resampling} spatial sampling (scaling) support
38 ${toggle_realtime_only} enable this option while building for real-time encoding
39 ${toggle_runtime_cpu_detect} runtime cpu detection
40 ${toggle_shared} shared library support
41 ${toggle_arm_asm_detok} assembly version of the detokenizer (ARM platforms only)
44 Codecs can be selectively enabled or disabled individually, or by family:
47 --disable-<codec>-encoder
48 --disable-<codec>-decoder
50 Codecs available in this distribution:
52 #restore editor state '
58 for c in ${CODECS}; do
60 if [ "${family}" != "${last_family}" ]; then
61 [ -z "${str}" ] || echo "${str}"
62 str="$(printf ' %10s:' ${family})"
64 str="${str} $(printf '%10s' ${c#*_})"
72 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
75 # all_platforms is a list of all supported target platforms. Maintain
76 # alphabetically by architecture, generic-gnu last.
77 all_platforms="${all_platforms} armv5te-linux-rvct"
78 all_platforms="${all_platforms} armv5te-linux-gcc"
79 all_platforms="${all_platforms} armv5te-symbian-gcc"
80 all_platforms="${all_platforms} armv5te-wince-vs8"
81 all_platforms="${all_platforms} armv6-darwin-gcc"
82 all_platforms="${all_platforms} armv6-linux-rvct"
83 all_platforms="${all_platforms} armv6-linux-gcc"
84 all_platforms="${all_platforms} armv6-symbian-gcc"
85 all_platforms="${all_platforms} armv6-wince-vs8"
86 all_platforms="${all_platforms} iwmmxt-linux-rvct"
87 all_platforms="${all_platforms} iwmmxt-linux-gcc"
88 all_platforms="${all_platforms} iwmmxt-wince-vs8"
89 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
90 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
91 all_platforms="${all_platforms} iwmmxt2-wince-vs8"
92 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
93 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
94 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
95 all_platforms="${all_platforms} mips32-linux-gcc"
96 all_platforms="${all_platforms} ppc32-darwin8-gcc"
97 all_platforms="${all_platforms} ppc32-darwin9-gcc"
98 all_platforms="${all_platforms} ppc32-linux-gcc"
99 all_platforms="${all_platforms} ppc64-darwin8-gcc"
100 all_platforms="${all_platforms} ppc64-darwin9-gcc"
101 all_platforms="${all_platforms} ppc64-linux-gcc"
102 all_platforms="${all_platforms} x86-darwin8-gcc"
103 all_platforms="${all_platforms} x86-darwin8-icc"
104 all_platforms="${all_platforms} x86-darwin9-gcc"
105 all_platforms="${all_platforms} x86-darwin9-icc"
106 all_platforms="${all_platforms} x86-linux-gcc"
107 all_platforms="${all_platforms} x86-linux-icc"
108 all_platforms="${all_platforms} x86-solaris-gcc"
109 all_platforms="${all_platforms} x86-win32-gcc"
110 all_platforms="${all_platforms} x86-win32-vs7"
111 all_platforms="${all_platforms} x86-win32-vs8"
112 all_platforms="${all_platforms} x86-win32-vs9"
113 all_platforms="${all_platforms} x86_64-darwin9-gcc"
114 all_platforms="${all_platforms} x86_64-linux-gcc"
115 all_platforms="${all_platforms} x86_64-linux-icc"
116 all_platforms="${all_platforms} x86_64-solaris-gcc"
117 all_platforms="${all_platforms} x86_64-win64-vs8"
118 all_platforms="${all_platforms} x86_64-win64-vs9"
119 all_platforms="${all_platforms} universal-darwin8-gcc"
120 all_platforms="${all_platforms} universal-darwin9-gcc"
121 all_platforms="${all_platforms} generic-gnu"
123 # all_targets is a list of all targets that can be configured
124 # note that these should be in dependency order for now.
125 all_targets="libs examples docs"
127 # all targets available are enabled, by default.
128 for t in ${all_targets}; do
129 [ -f ${source_path}/${t}.mk ] && enable ${t}
132 # check installed doxygen version
133 doxy_version=$(doxygen --version 2>/dev/null)
134 doxy_major=${doxy_version%%.*}
135 if [ ${doxy_major:-0} -ge 1 ]; then
136 doxy_version=${doxy_version#*.}
137 doxy_minor=${doxy_version%%.*}
138 doxy_patch=${doxy_version##*.}
140 [ $doxy_major -gt 1 ] && enable doxygen
141 [ $doxy_minor -gt 5 ] && enable doxygen
142 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
145 # install everything except the sources, by default. sources will have
146 # to be enabled when doing dist builds, since that's no longer a common
148 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
153 enable fast_unaligned #allow unaligned accesses, if supported by hw
155 enable spatial_resampling
158 [ -d ${source_path}/../include ] && enable alt_tree_layout
160 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
163 if ! enabled alt_tree_layout; then
164 # development environment
165 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
167 # customer environment
168 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
169 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
171 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
174 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
175 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
291 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
292 *) process_common_cmdline $opt
298 post_process_cmdline() {
301 # If the codec family is disabled, disable all components of that family.
302 # If the codec family is enabled, enable all components of that family.
303 log_echo "Configuring selected codecs"
304 for c in ${CODECS}; do
305 disabled ${c%%_*} && disable ${c}
306 enabled ${c%%_*} && enable ${c}
309 # Enable all detected codecs, if they haven't been disabled
310 for c in ${CODECS}; do soft_enable $c; done
312 # Enable the codec family if any component of that family is enabled
313 for c in ${CODECS}; do
314 enabled $c && enable ${c%_*}
317 # Set the {en,de}coders variable if any algorithm in that class is enabled
318 for c in ${CODECS}; do
319 enabled ${c} && enable ${c##*_}s
327 enabled child || write_common_config_banner
328 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
330 # TODO: add host tools target (obj_int_extract, etc)
332 # For fat binaries, call configure recursively to configure for each
333 # binary architecture to be included.
334 if enabled universal; then
335 # Call configure (ourselves) for each subarchitecture
336 for arch in $fat_bin_archs; do
337 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
341 # The write_common_config (config.mk) logic is deferred until after the
342 # recursive calls to configure complete, becuase we want our universal
343 # targets to be executed last.
344 write_common_config_targets
345 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
347 # Calculate the default distribution name, based on the enabled features
350 for cf in $CODEC_FAMILIES; do
351 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
352 DIST_DIR="${DIST_DIR}-${cf}"
353 elif enabled ${cf}_encoder; then
354 DIST_DIR="${DIST_DIR}-${cf}cx"
355 elif enabled ${cf}_decoder; then
356 DIST_DIR="${DIST_DIR}-${cf}dx"
359 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
360 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
361 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
362 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
363 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
364 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
366 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
367 DIST_DIR="${DIST_DIR}-${tgt_cc}"
370 if [ -f "${source_path}/build/make/version.sh" ]; then
371 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
372 DIST_DIR="${DIST_DIR}-${ver}"
374 VERSION_PATCH=${ver##*.}
376 VERSION_MINOR=${ver##*.}
378 VERSION_MAJOR=${ver%.*}
380 enabled child || cat <<EOF >> config.mk
381 ifeq (\$(MAKECMDGOALS),dist)
382 DIST_DIR?=${DIST_DIR}
384 DIST_DIR?=\$(DESTDIR)${prefix}
386 LIBSUBDIR=${libdir##${prefix}/}
388 VERSION_MAJOR=${VERSION_MAJOR}
389 VERSION_MINOR=${VERSION_MINOR}
390 VERSION_PATCH=${VERSION_PATCH}
392 CONFIGURE_ARGS=${CONFIGURE_ARGS}
394 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
397 # Write makefiles for all enabled targets
399 for tgt in libs examples docs solution; do
400 local tgt_fn="$tgt-$toolchain.mk"
402 if enabled $tgt; then
403 echo "Creating makefiles for ${toolchain} ${tgt}"
404 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
412 if enabled shared; then
413 # Can only build shared libs on a subset of platforms. Doing this check
414 # here rather than at option parse time because the target auto-detect
415 # magic happens after the command line has been parsed.
416 enabled linux || die "--enable-shared only supported on ELF for now"
418 if [ -z "$CC" ]; then
419 echo "Bypassing toolchain for environment detection."
420 enable external_build
422 log fake_check_header "$@"
425 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
434 [ -f "${d##-I}/$header" ] && result=true && break
443 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
444 check_ld <<EOF || die "Toolchain is unable to link executables"
445 int main(void) {return 0;}
447 # check system headers
448 check_header stdint.h
449 check_header pthread.h
450 check_header sys/mman.h
452 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
455 process_toolchain() {
456 process_common_toolchain
458 # Handle universal binaries for this architecture
461 local darwin_ver=${tgt_os##darwin}
462 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
465 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
466 if [ $darwin_ver -gt 8 ]; then
467 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
473 # Enable some useful compiler flags
475 enabled werror && check_add_cflags -Werror
476 check_add_cflags -Wall
477 check_add_cflags -Wdeclaration-after-statement
478 check_add_cflags -Wdisabled-optimization
479 check_add_cflags -Wpointer-arith
480 check_add_cflags -Wtype-limits
481 check_add_cflags -Wcast-qual
482 enabled extra_warnings || check_add_cflags -Wno-unused
486 enabled werror && check_add_cflags -Werror
487 check_add_cflags -Wall
488 check_add_cflags -Wpointer-arith
490 # ICC has a number of floating point optimizations that we disable
491 # in favor of deterministic output WRT to other compilers
492 add_cflags -fp-model precise
495 # Enable extra, harmless warnings. These might provide additional insight
496 # to what the compiler is doing and why, but in general, but they shouldn't
497 # be treated as fatal, even if we're treating warnings as errors.
499 -Wdisabled-optimization
502 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
503 RVCT_EXTRA_WARNINGS="
506 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
507 if enabled extra_warnings; then
508 for w in ${EXTRA_WARNINGS}; do
509 check_add_cflags ${w}
510 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
514 # ccache only really works on gcc toolchains
515 enabled gcc || soft_disable ccache
516 if enabled mips; then
517 enable dequant_tokens
521 # Enable the postbuild target if building for visual studio.
525 vs_version=${tgt_cc##vs}
526 all_targets="${all_targets} solution"
530 # Other toolchain specific defaults
531 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
536 ## END APPLICATION SPECIFIC CONFIGURATION
540 cat <<EOF > ${BUILD_PFX}vpx_config.c
541 static const char* const cfg = "$CONFIGURE_ARGS";
542 const char *vpx_codec_build_config(void) {return cfg;}